package Geometria;

/*
 * Parallelogramma.java
 *
 * Created on 30 marzo 2007, 9.58
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @Vittorio Albertoni
 */

/**
 *Questa classe serve per calcolare le grandezze del parallelogramma
 */
public class Parallelogramma
{
    
    /** Crea l' istanza di un Parallelogramma.
     *Per i parametri che non si intendono inserire, inserire 0.
     *@param angolo Angolo acuto tra la base e il lato obliquo, espresso in gradi.
     */
    public Parallelogramma(double base, double altezza, double latoObliquo, double angolo, double area, double diagonaleCorta, double diagonaleLunga, double perimetro)
    {
        b = base;
        h = altezza;
        lo = latoObliquo;
        an = angolo;
        a = area;
        dc = diagonaleCorta;
        dl = diagonaleLunga;
        p = perimetro;
    }
    
    /**Calcola la base, note altezza e area.
     */
    public double base_altezza_area()
    {
        double base = a/h;
        return base;
    }
    
    /**Calcola la base, noti lato obliquo e perimetro.
     */
    public double base_latoObliquo_perimetro()
    {
        double base = (p-2*lo)/2;
        return base;
    }
    
    /**Calcola la base, note altezza, lato obliquo e diagonale corta.
     */
    public double base_altezza_latoObliquo_diagonaleCorta()
    {
        double primo_segmento = Math.sqrt(lo*lo-h*h);
        double secondo_segmento = Math.sqrt(dc*dc-h*h);
        double base = primo_segmento+secondo_segmento;
        return base;
    }
    
    /**Calcola la base, noti altezza, angolo e diagonale corta.
     */
    public double base_altezza_angolo_diagonaleCorta()
    {
        double lato_obliquo = h/Math.sin(an/R);
        double primo_segmento = Math.sqrt(lato_obliquo*lato_obliquo-h*h);
        double secondo_segmento = Math.sqrt(dc*dc-h*h);
        double base = primo_segmento+secondo_segmento;
        return base;
    }
    
    /**Calcola la base, noti altezza, angolo e diagonale lunga.
     */
    public double base_altezza_angolo_diagonaleLunga()
    {
        double lato_obliquo = h/Math.sin(an/R);
        double diff_base = lato_obliquo*Math.cos(an/R);
        double base_estesa = Math.sqrt(dl*dl-h*h);
        double base = base_estesa - diff_base;
        return base;
    }
    
    /**Calcola la base, noti altezza, angolo e perimetro.
     */
    public double base_altezza_angolo_perimetro()
    {
        double lato_obliquo = h/Math.sin(an/R);
        double base = (p - 2*lato_obliquo)/2;
        return base;
    }
    
    /**Calcola la base, noti lato obliquo, angolo e area.
     */
    public double base_latoObliquo_angolo_area()
    {
        double altezza = lo*Math.sin(an/R);
        double base = a/altezza;
        return base;
    }
    
    /**Calcola la base, noti lato obliquo, angolo e diagonale corta.
     */
    public double base_latoObliquo_angolo_diagonaleCorta()
    {
        double altezza = lo*Math.sin(an/R);
        double primo_segmento_base = Math.sqrt(lo*lo-altezza*altezza);
        double secondo_segmento_base = Math.sqrt(dc*dc-altezza*altezza);
        double base = primo_segmento_base+secondo_segmento_base;
        return base;
    }
    
    /**Calcola la base, noti lato obliquo, angolo e diagonale lunga.
     */
    public double base_latoObliquo_angolo_diagonaleLunga()
    {
        double altezza = lo*Math.sin(an/R);
        double diff_base = Math.sqrt(lo*lo-altezza*altezza);
        double base_estesa = Math.sqrt(dl*dl-altezza*altezza);
        double base = base_estesa - diff_base;
        return base;
    }
    
    /**Calcola la base, noti altezza, lato obliquo e diagonale lunga.
     */
    public double base_altezza_latoObliquo_diagonaleLunga()
    {
        double diff_base = Math.sqrt(lo*lo-h*h);
        double base_estesa = Math.sqrt(dl*dl-h*h);
        double base = base_estesa - diff_base;
        return base;
    }
    
    /**Calcola l'altezza, note base e area.
     */
    public double altezza_base_area()
    {
        double altezza = a/b;
        return altezza;
    }
    
    /**Calcola l'altezza, noti lato obliquo e angolo.
     */
    public double altezza_latoObliquo_angolo()
    {
        double altezza = lo*Math.sin(an/R);
        return altezza;
    }
    
    /**Calcola l'altezza, noti base, angolo e perimetro.
     */
    public double altezza_base_angolo_perimetro()
    {
        double latoObliquo = (p-2*b)/2;
        double altezza = latoObliquo*Math.sin(an/R);
        return altezza;
    }
    
    /**Calcola il lato obliquo, noti base e perimetro.
     */
    public double latoObliquo_base_perimetro()
    {
        double latoObliquo = (p-2*b)/2;
        return latoObliquo;
    }
    
    /**Calcola il lato obliquo, noti altezza e angolo.
     */
    public double latoObliquo_altezza_angolo()
    {
        double latoObliquo = h/Math.sin(an/R);
        return latoObliquo;
    }
    
    /**Calcola il lato obliquo, noti base, angolo e area.
     */
    public double latoObliquo_base_angolo_area()
    {
        double altezza = a/b;
        double latoObliquo = altezza/Math.sin(an/R);
        return latoObliquo;
    }
    
    /**Calcola il lato obliquo, noti altezza, area e perimetro.
     */
    public double latoObliquo_altezza_area_perimetro()
    {
        double base = a/h;
        double latoObliquo = (p-2*base)/2;
        return latoObliquo;
    }
    
    /**Calcola l'angolo, noti altezza e lato obliquo.
     */
    public double angolo_altezza_latoObliquo()
    {
        double angolo = Math.asin(h/lo)*R;
        return angolo;
    }
    
    /**Calcola l'angolo, noti base, lato obliquo e area.
     */
    public double angolo_base_latoObliquo_area()
    {
        double altezza = a/b;
        double angolo = Math.asin(altezza/lo)*R;
        return angolo;
    }
    
    /**Calcola l'area, note base e altezza.
     */
    public double area_base_altezza()
    {
        double area = b*h;
        return area;
    }
    
    /**Calcola l'area, noti base, lato obliquo e angolo.
     */
    public double area_base_latoObliquo_angolo()
    {
        double area = b*lo*Math.sin(an/R);
        return area;
    }
    
    /**Calcola la diagonale corta, noti base, altezza e lato obliquo.
     */
    public double diagonaleCorta_base_altezza_latoObliquo()
    {
        double angolo = Math.asin(h/lo);
        double diff_base = 4*Math.cos(angolo);
        double base_ridotta = b - diff_base;
        double diagonaleCorta = Math.sqrt(base_ridotta*base_ridotta+h*h);
        return diagonaleCorta;
    }
    
    /**Calcola la diagonale corta, noti base, altezza e angolo.
     */
    public double diagonaleCorta_base_altezza_angolo()
    {
        double diff_base = 4*Math.cos(an/R);
        double base_ridotta = b - diff_base;
        double diagonaleCorta = Math.sqrt(base_ridotta*base_ridotta+h*h);
        return diagonaleCorta;
    }
    
    /**Calcola la diagonale lunga, noti base, altezza e lato obliquo.
     */
    public double diagonaleLunga_base_altezza_latoObliquo()
    {
        double angolo = Math.asin(h/lo);
        double diff_base = 4*Math.cos(angolo);
        double base_estesa = b + diff_base;
        double diagonaleLunga = Math.sqrt(base_estesa*base_estesa+h*h);
        return diagonaleLunga;
    }
    
    /**Calcola la diagonale lunga, noti base, altezza e angolo.
     */
    public double diagonaleLunga_base_altezza_angolo()
    {
        double diff_base = 4*Math.cos(an/R);
        double base_estesa = b + diff_base;
        double diagonaleLunga = Math.sqrt(base_estesa*base_estesa+h*h);
        return diagonaleLunga;
    }
    
    /**Calcola la diagonale lunga, note base, altezza e diagonale corta.
     */
    public double diagonaleLunga_base_altezza_diagonaleCorta()
    {
        double seconda_parte_base = Math.sqrt(dc*dc-h*h);
        double prima_parte_base = b-seconda_parte_base;
        double base_estesa = b + prima_parte_base;
        double diagonaleLunga = Math.sqrt(base_estesa*base_estesa+h*h);
        return diagonaleLunga;
    }
        
    /**Calcola il perimetro, noti base e lato obliquo.
     */
    public double perimetro_base_latoObliquo()
    {
        double perimetro = 2*b+2*lo;
        return perimetro;
    }
    
    /**Calcola il perimetro, noti altezza, lato obliquo e area.
     */
    public double perimetro_altezza_latoObliquo_area()
    {
        double base = a/h;
        double perimetro = 2*base+2*lo;
        return perimetro;
    }
    
    private double b;
    private double h;
    private double lo;
    private double an;
    private double a;
    private double dc;
    private double dl;
    private double p;
    final double R = 57.295795131;
}
