package Geometria;

/*
 * Piramide.java
 *
 * Created on 1 dicembre 2007, 11.39
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @Vittorio Albertoni
 */

/**Questa classe calcola le principali grandezze della Piramide.
 */

public class Piramide
{
    
    /** Crea l' istanza di una Piramide.
    *Per i parametri che non si intendono inserire, inserire 0.
    *@param raggioBase raggio del cerchio circoscritto alla base.
    *@param apotemaBase raggio del cerchio inscritto nella base.
    *@param altezza distanza perpendicolare tra il vertice e la base.
    *@param apotema altezza della faccia laterale.
    */
    public Piramide(int numeroLati, double latoBase,double raggioBase, double apotemaBase, double altezza, double apotema)
    {
        n = numeroLati;
        l = latoBase;
        r = raggioBase;
        ab = apotemaBase;
        h = altezza;
        a = apotema;
    }
    
    /**Calcola la superficie laterale, noti numero dei lati della base, lato della base e altezza della piramide.
     */
    public double superficieLaterale_numeroLati_latoBase_altezza()
    {
        double an = 90*(n-2)/n;
        double raggioBase = l*Math.sin(an/R)/Math.sin((Math.PI*R-2*an)/R);
        double apotemaBase = Math.sqrt(raggioBase*raggioBase-l/2*l/2);
        double apotema = Math.sqrt(apotemaBase*apotemaBase+h*h);
        double superficieLaterale = l*apotema/2*n;
        return superficieLaterale;
    }
    
    /**Calcola la superficie laterale, noti numero dei lati della base, raggio della base e altezza della piramide.
     */
    public double superficieLaterale_numeroLati_raggioBase_altezza()
    {
        double an = 90*(n-2)/n;
        double latoBase = r*Math.sin((Math.PI*R-2*an)/R)/Math.sin(an/R);
        double apotemaBase = Math.sqrt(r*r-latoBase/2*latoBase/2);
        double apotema = Math.sqrt(apotemaBase*apotemaBase+h*h);
        double superficieLaterale = latoBase*apotema/2*n;
        return superficieLaterale;
    }
    
    /**Calcola la superficie laterale, noti numero dei lati della base, apotema della base e altezza della piramide.
     */
    public double superficieLaterale_numeroLati_apotemaBase_altezza()
    {
        double an = 90*(n-2)/n;
        double raggioBase = ab/Math.sin(an/R);
        double latoBase = raggioBase*Math.sin((Math.PI*R-2*an)/R)/Math.sin(an/R);
        double apotema = Math.sqrt(ab*ab+h*h);
        double superficieLaterale = latoBase*apotema/2*n;
        return superficieLaterale;
    }
    
    /**Calcola la superficie laterale, noti numero dei lati della base, lato della base e apotema della piramide.
     */
    public double superficieLaterale_numeroLati_latoBase_apotema()
    {
        double superficieLaterale = l*a/2*n;
        return superficieLaterale;
    }
    
    /**Calcola la superficie laterale, noti numero dei lati della base, raggio della base e apotema della piramide.
     */
    public double superficieLaterale_numeroLati_raggioBase_apotema()
    {
        double an = 90*(n-2)/n;
        double latoBase = r*Math.sin((Math.PI*R-2*an)/R)/Math.sin(an/R);
        double superficieLaterale = latoBase*a/2*n;
        return superficieLaterale;
    }
    
    /**Calcola la superficie laterale, noti numero dei lati della base, apotema della base e apotema della piramide.
     */
    public double superficieLaterale_numeroLati_apotemaBase_apotema()
    {
        double an = 90*(n-2)/n;
        double raggioBase = ab/Math.sin(an/R);
        double latoBase = raggioBase*Math.sin((Math.PI*R-2*an)/R)/Math.sin(an/R);
        double superficieLaterale = latoBase*a/2*n;
        return superficieLaterale;
    }
    
    /**Calcola la superficie totale, noti numero dei lati della base, lato della base e altezza della piramide.
     */
    public double superficieTotale_numeroLati_latoBase_altezza()
    {
        double an = 90 * (n-2) / n;
        double raggioBase = l * Math.sin(an/R)/Math.sin((Math.PI * R - 2 * an) / R);
        double apotemaBase = Math.sqrt(raggioBase * raggioBase - l / 2 * l / 2);
        double areaBase = n * l * apotemaBase / 2;
        double apotema = Math.sqrt(apotemaBase*apotemaBase+h*h);
        double superficieLaterale = l*apotema/2*n;
        double superficieTotale = areaBase + superficieLaterale;
        return superficieTotale;
    }
    
     /**Calcola la superficie totale, noti numero dei lati della base, raggio della base e altezza della piramide.
     */
    public double superficieTotale_numeroLati_raggioBase_altezza()
    {
        double an = 90*(n-2)/n;
        double latoBase = r*Math.sin((Math.PI*R-2*an)/R)/Math.sin(an/R);
        double apotemaBase = Math.sqrt(r*r-latoBase/2*latoBase/2);
        double areaBase = n * latoBase * apotemaBase / 2;
        double apotema = Math.sqrt(apotemaBase*apotemaBase+h*h);
        double superficieLaterale = latoBase*apotema/2*n;
        double superficieTotale = areaBase + superficieLaterale;
        return superficieTotale;
    }
    
    /**Calcola la superficie totale, noti numero dei lati della base, apotema della base e altezza della piramide.
     */
    public double superficieTotale_numeroLati_apotemaBase_altezza()
    {
        double an = 90*(n-2)/n;
        double raggioBase = ab/Math.sin(an/R);
        double latoBase = raggioBase * Math.sin((Math.PI*R-2*an)/R)/Math.sin(an/R);
        double areaBase = n * latoBase * ab / 2;
        double apotema = Math.sqrt(ab*ab+h*h);
        double superficieLaterale = latoBase*apotema/2*n;
        double superficieTotale = areaBase + superficieLaterale;
        return superficieTotale;
    }
    
    /**Calcola la superficie totale, noti numero dei lati della base, lato della base e apotema della piramide.
     */
    public double superficieTotale_numeroLati_latoBase_apotema()
    {
        double an = 90 * (n-2) / n;
        double raggioBase = l * Math.sin(an/R)/Math.sin((Math.PI * R - 2 * an) / R);
        double apotemaBase = Math.sqrt(raggioBase * raggioBase - l / 2 * l / 2);
        double areaBase = n * l * apotemaBase / 2;
        double superficieLaterale = l*a/2*n;
        double superficieTotale = areaBase + superficieLaterale;
        return superficieTotale;
    }
    
    /**Calcola la superficie totale, noti numero dei lati della base, raggio della base e apotema della piramide:
     */
    public double  superficieTotale_numeroLati_raggioBase_apotema()
    {
        double an = 90*(n-2)/n;
        double latoBase = r*Math.sin((Math.PI*R-2*an)/R)/Math.sin(an/R);
        double apotemaBase = Math.sqrt(r*r-latoBase/2*latoBase/2);
        double areaBase = n * latoBase * apotemaBase / 2;
        double superficieLaterale = latoBase*a/2*n;
        double superficieTotale = areaBase + superficieLaterale;
        return superficieTotale;
    }
    
    /**Calcola la superficie totale, noti numero dei lati della base, apotema della base e apotema della piramide.
     */
    public double superficieTotale_numeroLati_apotemaBase_apotema()
    {
        double an = 90*(n-2)/n;
        double raggioBase = ab/Math.sin(an/R);
        double latoBase = raggioBase * Math.sin((Math.PI*R-2*an)/R)/Math.sin(an/R);
        double areaBase = n * latoBase * ab / 2;
        double superficieLaterale = latoBase*a/2*n;
        double superficieTotale = areaBase + superficieLaterale;
        return superficieTotale;
    }
    
    /**Calcola il volume, noti numero dei lati della base, lato della base e altezza della piramide.
     */
    public double volume_numeroLati_latoBase_altezza()
    {
        double an = 90 * (n-2) / n;
        double raggioBase = l * Math.sin(an/R)/Math.sin((Math.PI * R - 2 * an) / R);
        double apotemaBase = Math.sqrt(raggioBase * raggioBase - l / 2 * l / 2);
        double areaBase = n * l * apotemaBase / 2;
        double volume = areaBase * h / 3;
        return volume;
    }
    
    /**Calcola il volume, noti numero dei lati della base, raggio della base e altezza della piramide.
     */
    public double volume_numeroLati_raggioBase_altezza()
    {
        double an = 90*(n-2)/n;
        double latoBase = r*Math.sin((Math.PI*R-2*an)/R)/Math.sin(an/R);
        double apotemaBase = Math.sqrt(r*r-latoBase/2*latoBase/2);
        double areaBase = n * latoBase * apotemaBase / 2;
        double volume = areaBase * h / 3;
        return volume;
    }
    
    /**Calcola il volume, noti numero dei lati della base, apotema della base e altezza della piramide.
     */
    public double volume_numeroLati_apotemaBase_altezza()
    {
        double an = 90*(n-2)/n;
        double raggioBase = ab/Math.sin(an/R);
        double latoBase = raggioBase * Math.sin((Math.PI*R-2*an)/R)/Math.sin(an/R);
        double areaBase = n * latoBase * ab / 2;
        double volume = areaBase * h / 3;
        return volume;
    }
    
    /**Calcola il volume, noti numero dei lati della base, lato della base e apotema della piramide.
     */
    public double volume_numeroLati_latoBase_apotema()
    {
        double an = 90 * (n-2) / n;
        double raggioBase = l * Math.sin(an/R)/Math.sin((Math.PI * R - 2 * an) / R);
        double apotemaBase = Math.sqrt(raggioBase * raggioBase - l / 2 * l / 2);
        double areaBase = n * l * apotemaBase / 2;
        double altezza = Math.sqrt(a*a-apotemaBase*apotemaBase);
        double volume = areaBase * altezza / 3;
        return volume;
    }
    
    /**Calcola il volume, noti numero dei lati della base, raggio della base e apotema della piramide.
     */
    public double volume_numeroLati_raggioBase_apotema()
    {
        double an = 90*(n-2)/n;
        double latoBase = r*Math.sin((Math.PI*R-2*an)/R)/Math.sin(an/R);
        double apotemaBase = Math.sqrt(r*r-latoBase/2*latoBase/2);
        double areaBase = n * latoBase * apotemaBase / 2;
        double altezza = Math.sqrt(a*a-apotemaBase*apotemaBase);
        double volume = areaBase * altezza / 3;
        return volume;
    }
    
    /**Calcola il volume, noti numero dei lati della base, apotema della base e apotema della piramide.
     */
    public double volume_numeroLati_apotemaBase_apotema()
    {
        double an = 90*(n-2)/n;
        double raggioBase = ab/Math.sin(an/R);
        double latoBase = raggioBase * Math.sin((Math.PI*R-2*an)/R)/Math.sin(an/R);
        double areaBase = n * latoBase * ab / 2;
        double altezza = Math.sqrt(a*a-ab*ab);
        double volume = areaBase * altezza / 3;
        return volume;
    }
    
    private int n;
    private double l;
    private double r;
    private double ab;
    private double h;
    private double a;
    final double R = 57.295795131;
}
