package Geometria;

/*
 * Poligono.java
 *
 * Created on 1 dicembre 2007, 9.50
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @Vittorio Albertoni
 */

/** Questa classe calcola le grandezze del poligono regolare.
 */

public class Poligono
{
    
    /** Crea l' istanza di un Poligono regolare.
     * Per i parametri che non si intendono inserire, inserire 0.
     *@param raggio raggio del cerchio circoscritto al poligono.
     *@param apotema raggio del cerchio inscritto nel poligono.
     */
    public Poligono(int numeroLati, double lato, double raggio, double apotema, double  area, double perimetro) 
    {
        n = numeroLati;
        l = lato;
        r = raggio;
        ap = apotema;
        a = area;
        p = perimetro;
    }
    
    /**Calcola il lato, noti numero dei lati e raggio.
     */
    public double lato_numeroLati_raggio()
    {
        double an = 90*(n-2)/n;
        double lato = r*Math.sin((Math.PI*R-2*an)/R)/Math.sin(an/R);
        return lato;
    }
    
    /**Calcola il lato, noti numero dei lati e apotema.
     */
    public double lato_numeroLati_apotema()
    {
        double an = 90*(n-2)/n;
        double r = ap/Math.sin(an/R);
        double lato = r*Math.sin((Math.PI*R-2*an)/R)/Math.sin(an/R);
        return lato;
    }
    
    /**Calcola il lato, noti numero dei lati e perimetro.
     */
    public double lato_numeroLati_perimetro()
    {
        double lato = p/n;
        return lato;
    }
    
    /**Calcola il raggio, noti numero dei lati e lato.
     */
    public double raggio_numeroLati_lato()
    {
        double an = 90*(n-2)/n;
        double raggio = l*Math.sin(an/R)/Math.sin((Math.PI*R-2*an)/R);
        return raggio;
    }
    
    /**Calcola il raggio, noti numero dei lati e apotema.
     */
    public double raggio_numeroLati_apotema()
    {
        double an = 90*(n-2)/n;
        double raggio = ap/Math.sin(an/R);
        return raggio;
    }
    
    /**Calcola il raggio, noti numero dei lati e perimetro.
     */
    public double raggio_numeroLati_perimetro()
    {
        double an = 90*(n-2)/n;
        double lato = p/n;
        double raggio = lato*Math.sin(an/R)/Math.sin((Math.PI*R-2*an)/R);
        return raggio;
    }
    
    /**Calcola l'apotema, noti numero dei lati e lato.
     */
    public double apotema_numeroLati_lato()
    {
        double an = 90*(n-2)/n;
        double raggio = l*Math.sin(an/R)/Math.sin((Math.PI*R-2*an)/R);
        double apotema = Math.sqrt(raggio*raggio-l/2*l/2);
        return apotema;
    }
    
    /**Calcola l'apotema, noti numero dei lati e raggio.
     */
    public double apotema_numeroLati_raggio()
    {
        double an = 90*(n-2)/n;
        double lato = r*Math.sin((Math.PI*R-2*an)/R)/Math.sin(an/R);
        double apotema = Math.sqrt(r*r-lato/2*lato/2);
        return apotema;
    }
    
    /**Calcola l'apotema, noti numero dei lati e perimetro.
     */
    public double apotema_numeroLati_perimetro()
    {
        double lato = p/n;
        double an = 90*(n-2)/n;
        double raggio = lato*Math.sin(an/R)/Math.sin((Math.PI*R-2*an)/R);
        double apotema = Math.sqrt(raggio*raggio-lato/2*lato/2);
        return apotema;
    }
    
    /**Calcola l'area, noti numero dei lati e lato.
     */
    public double area_numeroLati_lato()
    {
        double an = 90 * (n-2) / n;
        double raggio = l * Math.sin(an/R)/Math.sin((Math.PI * R - 2 * an) / R);
        double apotema = Math.sqrt(raggio * raggio - l / 2 * l / 2);
        double area = n * l * apotema / 2;
        return area;
    }
    
    /**Calcola l'area, noti numero dei lati e raggio.
     */
    public double area_numeroLati_raggio()
    {
        double an = 90*(n-2)/n;
        double lato = r*Math.sin((Math.PI*R-2*an)/R)/Math.sin(an/R);
        double apotema = Math.sqrt(r*r-lato/2*lato/2);
        double area = n * lato * apotema / 2;
        return area;
    }
    
    /**Calcola l'area, noti numero dei lati e apotema.
     */
    public double area_numeroLati_apotema()
    {
        double an = 90*(n-2)/n;
        double raggio = ap/Math.sin(an/R);
        double lato = raggio * Math.sin((Math.PI*R-2*an)/R)/Math.sin(an/R);
        double area = n * lato * ap / 2;
        return area;
    }
    
    /**Calcola l'area, noti  numero dei lati e perimetro.
     */
    public double area_numeroLati_perimetro()
    {
        double lato = p/n;
        double an = 90 * (n-2) / n;
        double raggio = lato * Math.sin(an/R)/Math.sin((Math.PI * R - 2 * an) / R);
        double apotema = Math.sqrt(raggio * raggio - lato / 2 * lato / 2);
        double area = n * lato * apotema / 2;
        return area;
    }
    
    /**Calcola il perimetro, noti numero dei lati e lato.
     */
    public double perimetro_numeroLati_lato()
    {
        double perimetro = n * l;
        return perimetro;
    }
    
    /**Calcola il perimetro, noti numero dei lati e raggio.
     */
    public double perimetro_numeroLati_raggio()
    {
        double an = 90*(n-2)/n;
        double lato = r*Math.sin((Math.PI*R-2*an)/R)/Math.sin(an/R);
        double perimetro = n * lato;
        return perimetro;
    }
    
    /**Calcola il perimetro, noti numero dei lati e apotema.
     */
    public double perimetro_numeroLati_apotema()
    {
        double an = 90*(n-2)/n;
        double raggio = ap/Math.sin(an/R);
        double lato = raggio*Math.sin((Math.PI*R-2*an)/R)/Math.sin(an/R);
        double perimetro = n * lato;
        return perimetro;
    }
    
    /**Calcola l'angolo, noto il numero dei lati.
     */
    public double angolo()
    {
        double angolo = 2 * 90 * (n-2) / n;
        return angolo;
    }
    
    private int n;
    private double l;
    private double r;
    private double ap;
    private double a;
    private double p;
    final double R = 57.295795131;
}
