package Geometria;

/*
 * Rombo.java
 *
 * Created on 31 marzo 2007, 13.42
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @Vittorio Albertoni
 */

/**
 *Questa classe serve per calcolare le grandezze del rombo.
 */
public class Rombo 
{
    
    /**Crea l'istanza di un Rombo.
     * Per i parametri che non si intendono inserire, inserire 0.
     *@param angolo Angolo tra un lato e la diagonale, espresso in gradi.
     */
    public Rombo(double primaDiagonale, double secondaDiagonale, double lato, double area, double perimetro, double angolo)
    {
        d1 = primaDiagonale;
        d2 = secondaDiagonale;
        l = lato;
        a = area;
        p = perimetro;
        an = angolo;
    }
    
    /**Calcola il lato, noto il perimetro.
     */
    public double lato_perimetro()
    {
        double lato = p/4;
        return lato;
    }
    
    /**Calcola il perimetro, noto il lato.
     */
    public double perimetro_lato()
    {
        double perimetro = l*4;
        return perimetro;
    }
    
    /**Calcola il lato, note le diagonali.
     */
    public double lato_primaDiagonale_secondaDiagonale()
    {
        double lato = Math.sqrt(d1/2*d1/2+d2/2*d2/2);
        return lato;
    }
    
    /**Calcola l'area, note le diagonali.
     */
    public double area_primaDiagonale_secondaDiagonale()
    {
        double area = d1*d2/2;
        return area;
    }
    
    /**Calcola il perimetro, note le diagonali.
     */
    public double perimetro_primaDiagonale_secondaDiagonale()
    {
        double l = Math.sqrt(d1/2*d1/2+d2/2*d2/2);
        double perimetro = l*4;
        return perimetro;
    }
    
    /**Calcola l'angolo, espresso in gradi, tra un lato e una diagonale.
     */
    public double angolo_primaDiagonale_secondaDiagonale()
    {
        double lato = Math.sqrt(d1/2*d1/2+d2/2*d2/2);
        double angolo = Math.asin(d2/2/lato)*R;
        return angolo;
    }
    
    /**Calcola la seconda diagonale, noti prima diagonale e lato.
     */
    public double secondaDiagonale_primaDiagonale_lato()
    {
        double secondaDiagonale = Math.sqrt(l*l-d1/2*d1/2)*2;
        return secondaDiagonale;
    }
    
    /**Calcola l'area, noti prima diagonale e lato.
     */
    public double area_primaDiagonale_lato()
    {
        double secondaDiagonale = Math.sqrt(l*l-d1/2*d1/2)*2;
        double area = secondaDiagonale*d1/2;
        return area;
    }
    
     /**Calcola l'angolo, in gradi, noti prima diagonale e lato.
      */
    public double angolo_primaDiagonale_lato()
    {
        double secondaDiagonale = Math.sqrt(l*l-d1/2*d1/2)*2;
        double angolo = Math.asin(secondaDiagonale/2/l)*R;
        return angolo;
    }
    
    /**Calcola la seconda diagonale, note prima diagonale e area.
     */
    public double secondaDiagonale_primaDiagonale_area()
    {
        double secondaDiagonale = 2*a/d1;
        return secondaDiagonale;
    }
    
    /**Calcola il lato, note prima diagonale e area.
     */
    public double lato_primaDiagonale_area()
    {
        double secondaDiagonale = 2*a/d1;
        double lato = Math.sqrt(d1/2*d1/2+secondaDiagonale/2*secondaDiagonale/2);
        return lato;
    }
    
    /**Calcola il perimetro, note prima diagonale e area.
     */
    public double perimetro_primaDiagonale_area()
    {
        double secondaDiagonale = 2*a/d1;
        double lato = Math.sqrt(d1/2*d1/2+secondaDiagonale/2*secondaDiagonale/2);
        double perimetro = lato*4;
        return perimetro;
    }
    
    /**Calcola l'angolo, note prima diagonale e area.
     */
    public double angolo_primaDiagonale_area()
    {
        double secondaDiagonale = 2*a/d1;
        double lato = Math.sqrt(d1/2*d1/2+secondaDiagonale/2*secondaDiagonale/2);
        double angolo = Math.asin(secondaDiagonale/2/lato)*R;
        return angolo;
    }
    
    /**Calcola la seconda diagonale, noti prima diagonale e perimetro.
     */
    public double secondaDiagonale_primaDiagonale_perimetro()
    {
        double lato = p/4;
        double secondaDiagonale = Math.sqrt(lato*lato-d1/2*d1/2)*2;
        return secondaDiagonale;
    }
    
    /**Calcola l'area, noti prima diagonale e perimetro.
     */
    public double area_primaDiagonale_perimetro()
    {
        double lato = p/4;
        double secondaDiagonale = Math.sqrt(lato*lato-d1/2*d1/2)*2;
        double area = d1*secondaDiagonale/2;
        return area;
    }
    
    /**Calcola l'angolo, noti prima diagonale e perimetro.
     */
    public double angolo_primaDiagonale_perimetro()
    {
        double lato = p/4;
        double secondaDiagonale = Math.sqrt(lato*lato-d1/2*d1/2)*2;
        double angolo = Math.asin(secondaDiagonale/2/lato)*R;
        return angolo;
    }
    
    /**Calcola la seconda diagonale, noti prima diagonale e angolo.
     */
    public double secondaDiagonale_primaDiagonale_angolo()
    {
        double doppioLato = d1/Math.cos(an/R);
        double secondaDiagonale = Math.sqrt(doppioLato*doppioLato-d1*d1);
        return secondaDiagonale;
    }
    
    /**Calcola il lato, noti prima diagonale e angolo.
     */
    public double lato_primaDiagonale_angolo()
    {
        double lato = (d1/Math.cos(an/R))/2;
        return lato;
    }
    
    /**Calcola l'area, noti prima diagonale e angolo.
     */
    public double area_primaDiagonale_angolo()
    {
        double doppioLato = d1/Math.cos(an/R);
        double secondaDiagonale = Math.sqrt(doppioLato*doppioLato-d1*d1);
        double area = d1*secondaDiagonale/2;
        return area;
    }
    
    /**Calcola il perimetro, noti prima diagonale e angolo.
     */
    public double perimetro_primaDiagonale_angolo()
    {
        double perimetro = 2*d1/Math.cos(an/R);
        return perimetro;
    }
    
    /**Calcola la prima diagonale, noti seconda diagonale e lato.
     */
    public double primaDiagonale_secondaDiagonale_lato()
    {
        double primaDiagonale = 2*Math.sqrt(l*l-(d2/2)*(d2/2));
        return primaDiagonale;
    }
    
    /**Calcola l'area, noti seconda diagonale e lato.
     */
    public double area_secondaDiagonale_lato()
    {
        double primaDiagonale = 2*Math.sqrt(l*l-(d2/2)*(d2/2));
        double area = primaDiagonale*d2/2;
        return area;
    }
    
    /**Calcola l'angolo, noti seconda diagonale e lato.
     */
    public double angolo_secondaDiagonale_lato()
    {
        double angolo = Math.asin((d2/2)/l)*R;
        return angolo;
    }
    
    /**Calcola la prima diagonale, note seconda diagonale e area.
     */
    public double primaDiagonale_secondaDiagonale_area()
    {
        double primaDiagonale = 2*a/d2;
        return primaDiagonale;
    }
    
    /**Calcola il lato, note seconda diagonale e area.
     */
    public double lato_secondaDiagonale_area()
    {
        double primaDiagonale = 2*a/d2;
        double lato = Math.sqrt((primaDiagonale/2)*(primaDiagonale/2)+d2/2*d2/2);
        return lato;
    }
    
    /**Calcola il perimetro, note seconda Diagonale e area.
     */
    public double perimetro_secondaDiagonale_area()
    {
        double primaDiagonale = 2*a/d2;
        double lato = Math.sqrt((primaDiagonale/2)*(primaDiagonale/2)+d2/2*d2/2);
        double perimetro = 4*lato;
        return perimetro;
    }
    
    /**Calcola l'angolo, note seconda diagonale e area.
     */
    public double angolo_secondaDiagonale_area()
    {
        double primaDiagonale = 2*a/d2;
        double lato = Math.sqrt((primaDiagonale/2)*(primaDiagonale/2)+d2/2*d2/2);
        double angolo = Math.asin((d2/2)/lato)*R;
        return angolo;
    }
    
    /**Calcola la prima diagonale, noti seconda diagonale e perimetro.
     */
    public double primaDiagonale_secondaDiagonale_perimetro()
    {
        double lato = p/4;
        double primaDiagonale = Math.sqrt(lato*lato-d2/2*d2/2)*2;
        return primaDiagonale;
    }
    
    /**Calcola l'area, noti seconda diagonale e perimetro.
     */
    public double area_secondaDiagonale_perimetro()
    {
        double lato = p/4;
        double primaDiagonale = Math.sqrt(lato*lato-d2/2*d2/2)*2;
        double area = d2*primaDiagonale/2;
        return area;
    }
    
    /**Calcola l'angolo, noti seconda diagonale e perimetro.
     */
    public double angolo_secondaDiagonale_perimetro()
    {
        double lato = p/4;
        double angolo = Math.asin(d2/2/lato)*R;
        return angolo;
    }
    
    /**Calcola la prima diagonale, noti seconda diagonale e angolo.
     */
    public double primaDiagonale_secondaDiagonale_angolo()
    {
        double doppioLato = d2/Math.sin(an/R);
        double primaDiagonale = Math.sqrt(doppioLato*doppioLato-d2*d2);
        return primaDiagonale;
    }
    
    /**Calcola il lato, noti seconda diagonale e angolo.
     */
    public double lato_secondaDiagonale_angolo()
    {
        double lato = (d2/Math.sin(an/R))/2;
        return lato;
    }
    
    /**Calcola l'area, noti seconda diagonale e angolo.
     */
    public double area_secondaDiagonale_angolo()
    {
        double doppioLato = d1/Math.cos(an/R);
        double primaDiagonale = Math.sqrt(doppioLato*doppioLato-d2*d2);
        double area = d2*primaDiagonale/2;
        return area;
    }
    
    /**Calcola il perimetro, noti seconda diagonale e angolo.
     */
    public double perimetro_secondaDiagonale_angolo()
    {
        double perimetro = 2*d2/Math.sin(an/R);
        return perimetro;
    }
    
    /**Calcola la prima diagonale, noti lato e angolo.
     */
    public double primaDiagonale_lato_angolo()
    {
        double primaDiagonale = 2*l*Math.cos(an/R);
        return primaDiagonale;
    }
    
    /**Calcola la secondaDiagonale, noti lato e angolo.
     */
    public double secondaDiagonale_lato_angolo()
    {
        double secondaDiagonale = 2*l*Math.sin(an/R);
        return secondaDiagonale;
    }
    
    /**Calcola l'area, noti lato e angolo.
     */
    public double area_lato_angolo()
    {
        double primaDiagonale = 2*l*Math.cos(an/R);
        double secondaDiagonale = 2*l*Math.sin(an/R);
        double area = primaDiagonale*secondaDiagonale/2;
        return area;
    }
    
    /**Calcola la prima diagonale, noti perimetro e angolo.
     */
    public double primaDiagonale_perimetro_angolo()
    {
        double lato = p/4;
        double primaDiagonale = 2*lato*Math.cos(an/R);
        return primaDiagonale;
    }
    
    /**Calcola la seconda diagonale, noti perimetro e angolo.
     */
    public double secondaDiagonale_perimetro_angolo()
    {
        double lato = p/4;
        double secondaDiagonale = 2*lato*Math.sin(an/R);
        return secondaDiagonale;
    }
    
    /**Calcola l'area, noti perimetro e angolo.
     */
    public double area_perimetro_angolo()
    {
        double lato = p/4;
        double primaDiagonale = 2*lato*Math.cos(an/R);
        double secondaDiagonale = 2*lato*Math.sin(an/R);
        double area = primaDiagonale*secondaDiagonale/2;
        return area;
    }
    
    private double d1;
    private double d2;
    private double l;
    private double a;
    private double p;
    private double an;
    final double R = 57.295795131;
    
}
