package Geometria;

/*
 * Triangolo.java
 *
 * Created on 2 aprile 2007, 16.02
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @Vittorio Albertoni
 */

/**
 *Questa classe serve per calcolare le grandezze del triangolo
 */

public class Triangolo
{
    
    /** Crea l'istanza di un Triangolo.
     *
     *Per i parametri che non si intendono inserire, inserire 0.
     *
     **VERIFICHE DI CONGRUENZA DEI PARAMETRI
     *(ad esempio che la somma dei tre angoli non sia superiore a 180 gradi, ecc.)
     *VANNO FATTE PRIMA DI ACCEDERE ALLE FUNZIONI DI QUESTA LIBRERIA.
     *@param secondoLato Lato sulla sinistra della base
     *@param terzoLato Lato sulla destra della base
     *@param primoAngolo Angolo,espresso in gradi, tra la base e il secondo lato
     *@param secondoAngolo Angolo, espresso in gradi, tra il secondo e il terzo lato
     *@param terzoAngolo Angolo, espresso in gradi, tra il terzo lato e la base
     */
    public Triangolo(double base, double secondoLato, double terzoLato, double altezza, double area, double perimetro, double primoAngolo, double secondoAngolo, double terzoAngolo) 
    {
        b = base;
        sl = secondoLato;
        tl = terzoLato;
        h = altezza;
        a = area;
        p = perimetro;
        a1 = primoAngolo;
        a2 = secondoAngolo;
        a3 = terzoAngolo;
    }
    
    /**Calcola l'area, note base e altezza.
     */
    public double area_base_altezza()
    {
        double area = b*h/2;
        return area;
    }
    
    /**Calcola l'altezza, note base e area.
     */
    public double altezza_base_area()
    {
        double altezza = 2*a/b;
        return altezza;
    }
    
    /**Calcola la base, note altezza e area.
     */
    public double base_altezza_area()
    {
        double base = 2*a/h;
        return base;
    }
    
    /**Calcola il secondo lato, noti altezza e primo angolo.
     */
    public double secondoLato_altezza_primoAngolo()
    {
        double secondoLato = h/Math.sin(a1/R);
        return secondoLato;
    }
    
    /**Calcola il terzo lato, noti altezza e terzo angolo.
     */
    public double terzoLato_altezza_terzoAngolo()
    {
        double terzoLato = h/Math.sin(a3/R);
        return terzoLato;
    }
    
    /**Calcola il perimetro, noti i tre lati.
     */
    public double perimetro_base_secondoLato_terzoLato()
    {
        double perimetro = b+sl+tl;
        return perimetro;
    }
    
    /**Calcola l'altezza, noti secondo lato e primo angolo.
     */
    public double altezza_secondoLato_primoAngolo()
    {
        double altezza = sl*Math.sin(a1/R);
        return altezza;
    }
    
    /**Calcola l'altezza, noti terzo lato e terzo angolo.
     */
    public double altezza_terzoLato_terzoAngolo()
    {
        double altezza = tl*Math.sin(a3/R);
        return altezza;
    }
    
    /**Calcola l'area, noti i tre lati.
     */
    public double area_base_secondoLato_terzoLato()
    {
        double sp = (b+sl+tl)/2;
        double area = Math.sqrt(sp*(sp-b)*(sp-sl)*(sp-tl));
        return area;
    }
    
    /**Calcola il primo angolo, noti i tre lati.
     */
    public double primoAngolo_base_secondoLato_terzoLato()
    {
        double primoAngolo = R*Math.acos((b*b+sl*sl-tl*tl)/(2*b*sl));
        return primoAngolo;
    }
    
    /**Calcola il secondo angolo, noti i tre lati.
     */
    public double secondoAngolo_base_secondoLato_terzoLato()
    {
        double secondoAngolo = R*Math.acos((sl*sl+tl*tl-b*b)/(2*sl*tl));
        return secondoAngolo;
    }
    
    /**Calcola il terzo angolo, noti i tre lati.
     */
    public double terzoAngolo_base_secondoLato_terzoLato()
    {
        double terzoAngolo = R*Math.acos((tl*tl+b*b-sl*sl)/(2*tl*b));
        return terzoAngolo;
    }
    
    /**Calcola il terzo lato, noti base, secondo lato e altezza.
     */
    public double terzoLato_base_secondoLato_altezza()
    {
        double seg_1_base = Math.sqrt(sl*sl-h*h);
        double seg_2_base = b - seg_1_base;
        double terzoLato = Math.sqrt(seg_2_base*seg_2_base+h*h);
        return terzoLato;
    }
    
    /**Calcola il terzo lato, noti base, secondo lato e area.
     */
    public double terzoLato_base_secondoLato_area()
    {
        double altezza = 2*a/b;
        double seg_1_base = Math.sqrt(sl*sl-altezza*altezza);
        double seg_2_base = b - seg_1_base;
        double terzoLato = Math.sqrt(seg_2_base*seg_2_base+altezza*altezza);
        return terzoLato;
    }
    
    /**Calcola il terzo lato, noti base, secondo lato e perimetro.
     */
    public double terzoLato_base_secondoLato_perimetro()
    {
        double terzoLato = p-b-sl;
        return terzoLato;
    }
    
    /**Calcola il terzo lato, noti base, secondo lato e primo angolo.
     */
    public double terzoLato_base_secondoLato_primoAngolo()
    {
        double terzoLato = Math.sqrt(b*b+sl*sl-2*b*sl*Math.cos(a1/R));
        return terzoLato;
    }
    
    /**Calcola il secondo angolo, noti base, secondo lato e primo angolo.
     */
    public double secondoAngolo_base_secondoLato_primoAngolo()
    {
        double terzoLato = Math.sqrt(b*b+sl*sl-2*b*sl*Math.cos(a1/R));
        double secondoAngolo = R*Math.acos((sl*sl+terzoLato*terzoLato-b*b)/(2*sl*terzoLato));
        return secondoAngolo;
    }
    
    /**Calcola il terzo angolo, noti base, secondo lato e primo angolo.
     */
    public double terzoAngolo_base_secondoLato_primoAngolo()
    {
        double terzoLato = Math.sqrt(b*b+sl*sl-2*b*sl*Math.cos(a1/R));
        double terzoAngolo = R*Math.acos((terzoLato*terzoLato+b*b-sl*sl)/(2*terzoLato*b));
        return terzoAngolo;
    }
    
    /**Calcola il secondo lato, noti base, terzo lato e altezza.
     */
    public double secondoLato_base_terzoLato_altezza()
    {
        double seg_2_base = Math.sqrt(tl*tl-h*h);
        double seg_1_base = b - seg_2_base;
        double secondoLato = Math.sqrt(seg_1_base*seg_1_base+h*h);
        return secondoLato;
    }
    
    /**Calcola il secondo lato, noti base, terzo lato e area.
     */
    public double secondoLato_base_terzoLato_area()
    {
        double altezza = 2*a/b;
        double seg_2_base = Math.sqrt(tl*tl-altezza*altezza);
        double seg_1_base = b - seg_2_base;
        double secondoLato = Math.sqrt(seg_1_base*seg_1_base+altezza*altezza);
        return secondoLato;
    }
    
    /**Calcola il secondo lato, noti base, terzo lato e perimetro.
     */
    public double secondoLato_base_terzoLato_perimetro()
    {
        double secondoLato = p-b-tl;
        return secondoLato;
    }
    
    /**Calcola il secondo lato, noti base, terzo lato e terzo angolo.
     */
    public double secondoLato_base_terzoLato_terzoAngolo()
    {
        double secondoLato = Math.sqrt(b*b+tl*tl-2*b*tl*Math.cos(a3/R));
        return secondoLato;
    }
    
    /**Calcola il primo angolo, noti base, terzo lato e terzo angolo.
     */
    public double primoAngolo_base_terzoLato_terzoAngolo()
    {
        double secondoLato = Math.sqrt(b*b+tl*tl-2*b*tl*Math.cos(a3/R));
        double primoAngolo = R*Math.acos((secondoLato*secondoLato+b*b-tl*tl)/(2*secondoLato*b));
        return primoAngolo;
    }
    
    /**Calcola il secondo angolo, noti base, terzo lato e terzo angolo.
     */
    public double secondoAngolo_base_terzoLato_terzoAngolo()
    {
        double secondoLato = Math.sqrt(b*b+tl*tl-2*b*tl*Math.cos(a3/R));
        double secondoAngolo = R*Math.acos((secondoLato*secondoLato+tl*tl-b*b)/(2*secondoLato*tl));
        return secondoAngolo;
    }
    
    /**Calcola il secondo lato, noti base, primo angolo e secondo angolo.
     */
    public double secondoLato_base_primoAngolo_secondoAngolo()
    {
        double secondoLato = b*Math.sin(a1/R+a2/R)/Math.sin(a2/R);
        return secondoLato;
    }
    
    /**Calcola il terzo lato, noti base, primo angolo e secondo angolo.
     */
    public double terzoLato_base_primoAngolo_secondoAngolo()
    {
        double terzoLato = b*Math.sin(a1/R)/Math.sin(a2/R);
        return terzoLato;
    }
    
    /**Calcola il secondo lato, noti base, primo angolo e terzo angolo.
     */
    public double secondoLato_base_primoAngolo_terzoAngolo()
    {
        double secondoLato = b*Math.sin(a3/R)/Math.sin((Math.PI*R-a1-a3)/R);
        return secondoLato;
    }
    
    /**Calcola il terzo lato, noti base, primo angolo e terzo angolo.
     */
    public double terzoLato_base_primoAngolo_terzoAngolo()
    {
        double terzoLato = b*Math.sin(a1/R)/Math.sin((Math.PI*R-a1-a3)/R);
        return terzoLato;
    }
    
    /**Calcola il secondo lato, noti base, secondo angolo e terzo angolo.
     */
    public double secondoLato_base_secondoAngolo_terzoAngolo()
    {
        double secondoLato = b*Math.sin(a3/R)/Math.sin(a2/R);
        return secondoLato;
    }
    
    /**Calcola il terzo lato, noti base, secondo angolo e terzo angolo.
     */
    public double terzoLato_base_secondoAngolo_terzoAngolo()
    {
        double terzoLato = b*Math.sin(a2/R+a3/R)/Math.sin(a2/R);
        return terzoLato;
    }
    
    /**Calcola la base, noti secondo lato, terzo lato e altezza.
     */
    public double base_secondoLato_terzoLato_altezza()
    {
        double segm_1 = Math.sqrt(sl*sl-h*h);
        double segm_2 = Math.sqrt(tl*tl-h*h);
        double base = segm_1+segm_2;
        return base;
    }
    
    /**Calcola la base, noti secondo lato, terzo lato e perimetro.
     */
    public double base_secondoLato_terzoLato_perimetro()
    {
        double base = p-sl-tl;
        return base;
    }
    
    /**Calcola la base, noti secondo lato, terzo lato e secondo angolo.
     */
    public double base_secondoLato_terzoLato_secondoAngolo()
    {
        double base = Math.sqrt(sl*sl+tl*tl-2*sl*tl*Math.cos(a2/R));
        return base;
    }
    
    /**Calcola il primo angolo, noti secondo lato, terzo lato e secondo angolo.
     */
    public double primoAngolo_secondoLato_terzoLato_secondoAngolo()
    {
        double base = Math.sqrt(sl*sl+tl*tl-2*sl*tl*Math.cos(a2/R));
        double primoAngolo = R*Math.acos((base*base+sl*sl-tl*tl)/(2*base*sl));
        return primoAngolo;
    }
    
    /**Calcola il terzo angolo, noti secondo lato, terzo lato e secondo angolo.
     */
    public double terzoAngolo_secondoLato_terzoLato_secondoAngolo()
    {
        double base = Math.sqrt(sl*sl+tl*tl-2*sl*tl*Math.cos(a2/R));
        double terzoAngolo = R*Math.acos((base*base+tl*tl-sl*sl)/(2*base*tl));
        return terzoAngolo;
    }
    
    /**Calcola l'altezza, noti secondo lato, terzo lato e secondo angolo.
     */
    public double altezza_secondoLato_terzoLato_secondoAngolo()
    {
        double base = Math.sqrt(sl*sl+tl*tl-2*sl*tl*Math.cos(a2/R));
        double primoAngolo = R*Math.acos((base*base+sl*sl-tl*tl)/(2*base*sl));
        double altezza = sl*Math.sin(primoAngolo/R);
        return altezza;
    }
    
    /**Calcola la base, noti secondo lato, primo angolo e secondo angolo.
     */
    public double base_secondoLato_primoAngolo_secondoAngolo()
    {
        double base = sl*Math.sin(a2/R)/Math.sin((Math.PI*R-a1-a2)/R);
        return base;
    }
    
    /**Calcola il terzo lato, noti secondo lato, primo angolo e secondo angolo.
     */
    public double terzoLato_secondoLato_primoAngolo_secondoAngolo()
    {
        double terzoLato = sl*Math.sin(a1/R)/Math.sin((Math.PI*R-a1-a2)/R);
        return terzoLato;
    }
    
    /**Calcola la base, noti secondo lato, primo angolo e terzo angolo.
     */
    public double base_secondoLato_primoAngolo_terzoAngolo()
    {
        double base = sl*Math.sin(a1/R+a3/R)/Math.sin(a3/R);
        return base;
    }
    
    /**Calcola il terzo lato, noti secondo lato, primo angolo e terzo angolo.
     */
    public double terzoLato_secondoLato_primoAngolo_terzoAngolo()
    {
        double terzoLato = sl*Math.sin(a1/R)/Math.sin(a3/R);
        return terzoLato;
    }
    
    /**Calcola la base, noti secondo lato, secondo angolo e terzo angolo.
     */
    public double base_secondoLato_secondoAngolo_terzoAngolo()
    {
        double base = sl*Math.sin(a2/R)/Math.sin(a3/R);
        return base;
    }
    
    /**Calcola il terzo lato, noti secondo lato, secondo angolo e terzo angolo.
     */
    public double terzoLato_secondoLato_secondoAngolo_terzoAngolo()
    {
        double terzoLato = sl*Math.sin(a2/R+a3/R)/Math.sin(a3/R);
        return terzoLato;
    }
    
    /**Calcola la base, noti terzo lato, primo angolo e secondo angolo.
     */
    public double base_terzoLato_primoAngolo_secondoAngolo()
    {
        double base = tl*Math.sin(a2/R)/Math.sin(a1/R);
        return base;
    }
    
    /**Calcola il secondo lato, noti terzo lato, primo angolo e secondo angolo.
     */
    public double secondoLato_terzoLato_primoAngolo_secondoAngolo()
    {
        double secondoLato = tl*Math.sin(a1/R+a2/R)/Math.sin(a1/R);
        return secondoLato;
    }
    
    /**Calcola la base, noti terzo lato, primo angolo e terzo angolo.
     */
    public double base_terzoLato_primoAngolo_terzoAngolo()
    {
        double base = tl*Math.sin(a1/R+a3/R)/Math.sin(a1/R);
        return base;
    }
    
    /**Calcola il secondo lato, noti terzo lato, primo angolo e terzo angolo.
     */
    public double secondoLato_terzoLato_primoAngolo_terzoAngolo()
    {
        double secondoLato = tl*Math.sin(a3/R)/Math.sin(a1/R);
        return secondoLato;
    }
    
    /**Calcola la base, noti terzo lato, secondo angolo e terzo angolo.
     */
    public double base_terzoLato_secondoAngolo_terzoAngolo()
    {
        double base = tl*Math.sin(a2/R)/Math.sin((Math.PI*R-a3-a2)/R);
        return base;
    }
    
    /**Calcola il secondo lato, noti terzo lato, secondo angolo e terzo angolo.
     */
    public double secondoLato_terzoLato_secondoAngolo_terzoAngolo()
    {
        double secondoLato = tl*Math.sin(a3/R)/Math.sin((Math.PI*R-a2-a3)/R);
        return secondoLato;
    }
       
    private double b;
    private double sl;
    private double tl;
    private double h;
    private double a;
    private double p;
    private double a1;
    private double a2;
    private double a3;
    final double R = 57.295795131;
}
